<template>
  <div>
    <div v-if="isLoading">Loading ......</div>
    <div v-else>
      <div class="card-container">
        <div v-for="item in getItemsList" :key="item.id" class="card">
          <h2>{{ item.title }}</h2>
          <p>{{ item.description }}</p>
          <img v-if="item.imgSrc" :src="item.imgSrc" alt="Item Image" class="card-image" />
          <div class="card-buttons">
            <button  @click="deleteItem(item.id)">Delete</button>
          </div>
        </div>
      </div>
      <hr />
      <button @click="goToAddPage">Додати до галереї</button>
      <hr />
      <div class="input-container">
        <label for="targetDescription">Description to find</label>
        <input v-model="targetDescription" type="text" id="targetDescription" />
      </div>
      <button @click="loadFilteredDataByPrice">Filter</button>
    </div>
  </div>
</template>


<script>
import { mapGetters, mapActions } from 'vuex';

export default {
  name: 'HomeView',
  components: {},

  data() {
    return {
      product: {
        title: '',
        description: '',
        imgSrc: '',
        image: null,
      },
      targetDescription: null,
    };
  },

  computed: {
    ...mapGetters('products', ['getItemsList', 'isLoading']),
    //...mapGetters('users',['userPermissions'])
  },

  created() {
    this.loadList();
    //console.log('Permissions:', this.userPermissions);
  },

  methods: {
    ...mapActions('products', ['loadList', 'addItem', 'deleteItem', 'updateItem', 'loadFilteredData']),

    loadFilteredDataByPrice() {
        if (this.targetDescription && this.targetDescription.trim() !== '') {
          this.loadFilteredData({
            fieldTitle: 'description',
            compareOperator: '==',
            valueToCompare: this.targetDescription.trim()
          });
        } else {
          this.loadList(); 
        }
      },
      goToAddPage(){
        this.$router.push('/add')
      },
    onImageChange(event) {
      const file = event.target.files[0];
      if (file) {
        this.product.image = URL.createObjectURL(file);
      }
    },
    
  
  },
};
</script>

<style scoped>
.card-container {
  display: flex;
  flex-wrap: wrap;
  justify-content: space-between;
}

.card {
  border: 1px solid #3a2f2f;
  border-radius: 8px;
  padding: 16px;
  margin-bottom: 16px;
  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.3);
}

.card h2 {
  margin-bottom: 8px;
}

.card p {
  margin-bottom: 12px;
}

.card-image {
  max-width: 100%;
  height: auto;
  border-radius: 8px;
  margin-bottom: 12px;
}

.card-buttons button {
  margin-right: 8px;
  padding: 8px;
  background-color: #1e411f;
  color: white;
  border: none;
  border-radius: 4px;
  cursor: pointer;
}

.input-container {
  max-width: 300px; 
  margin-bottom: 12px;
}

div {
  margin-bottom: 12px;
}

label {
  display: block;
  margin-bottom: 4px;
}

input {
  width: 100%;
  padding: 8px;
  box-sizing: border-box;
  border: 1px solid #684545;
  border-radius: 4px;
  margin-bottom: 8px;
}

button {
  padding: 8px;
  background-color: #1e3b1f;
  color: rgb(255, 255, 255);
  border: none;
  border-radius: 4px;
  cursor: pointer;
}

hr {
  margin: 24px 0;
  border: 0;
  border-top: 1px solid #251a1a;
}
</style>
